﻿//----------------------------------------------------------------------------
// <copyright file="PluralType.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//----------------------------------------------------------------------------
namespace Dax
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// PluralType enumeration.
    /// </summary>
    public enum PluralType
    {
        /// <summary>
        /// No pluralization processing.
        /// </summary>
        None = 0,

        /// <summary>
        /// Database table names are singular convert to plural during generating.
        /// </summary>
        Pluralize = 1,

        /// <summary>
        /// Database table names are plurals convert to singular during generation.
        /// </summary>
        Singlize = 2
    }
}
