﻿//----------------------------------------------------------------------------
// <copyright file="StringExtensions.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//----------------------------------------------------------------------------
namespace Dax
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Text.RegularExpressions;
    using System.Globalization;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public static class StringExtensions
    {
        public static string CapitalizeFirstChar(this string text)
        {
            return text.Substring(0, 1).ToUpperInvariant() + text.Substring(1);
        }

        public static string ToCamel(this string text)
        {
            return text.Substring(0, 1).ToLowerInvariant() + text.Substring(1);
        }

        public static string TrimEnd(this string text, int length)
        {
            return text.Remove(text.Length - length);
        }

        public static string RemoveWhiteSpace(this string text)
        {
            return Regex.Replace(text, @"\s", "");
        }
    }
}
