﻿//-----------------------------------------------------------------------
// <copyright file="DBRelationship.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//-----------------------------------------------------------------------
namespace Dax.Database
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public class DBRelationship : DBObject
    {
        private DBTable parentTable;
        private DBTable referencedTable;
        private Dictionary<int, DBRelationshipColumn> columns = new Dictionary<int, DBRelationshipColumn>();

        #region Constructors
        /// <summary>
        /// Initializes a new instance of the DBRelationship class.
        /// </summary>
        public DBRelationship(DBDatabase dbDatabase, int id, string name, DBTable parentTable, DBTable referencedTable) 
            :base(dbDatabase, id, name)
        {
            this.parentTable = parentTable;
            this.referencedTable = referencedTable;
        }
        #endregion

        /// <summary>
        /// Gets the columns.
        /// </summary>
        /// <value>The Database Types.</value>
        public Dictionary<int, DBRelationshipColumn> Columns
        {
            get
            {
                return this.columns;
            }
        }

        /// <summary>
        /// Gets the columns.
        /// </summary>
        /// <value>The Database Types.</value>
        public IList<DBColumn> ParentColumns
        {
            get
            {
                return (from rc in this.columns.Values
                       select rc.ParentColumn).ToList();
            }
        }

        /// <summary>
        /// Gets the columns.
        /// </summary>
        /// <value>The Database Types.</value>
        public IList<DBColumn> ReferencedColumns
        {
            get
            {
                return (from rc in this.columns.Values
                       select rc.ReferencedColumn).ToList();
            }
        }

        /// <summary>
        /// Gets the columns.
        /// </summary>
        /// <value>The Database Types.</value>
        public DBTable ParentTable
        {
            get
            {
                return this.parentTable;
            }
        }

        /// <summary>
        /// Gets the columns.
        /// </summary>
        /// <value>The Database Types.</value>
        public DBTable ReferencedTable
        {
            get
            {
                return this.referencedTable;
            }
        }
    }
}
