﻿//-----------------------------------------------------------------------
// <copyright file="DBRelationshipColumn.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//-----------------------------------------------------------------------
namespace Dax.Database
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public class DBRelationshipColumn : DBObject
    {
        private DBColumn parentColumn;
        private DBColumn referencedColumn;
        
        #region Constructors
        /// <summary>
        /// Initializes a new instance of the DBRelationshipColumn class.
        /// </summary>
        public DBRelationshipColumn(DBDatabase dbDatabase, int objectId, DBColumn parentColumn, DBColumn referencedColumn) 
            :base(dbDatabase, objectId, "column")
        {
            this.parentColumn = parentColumn;
            this.referencedColumn = referencedColumn;
        }
        #endregion

        /// <summary>
        /// Gets the columns.
        /// </summary>
        /// <value>The Database Types.</value>
        public DBColumn ParentColumn
        {
            get
            {
                return this.parentColumn;
            }
        }

        /// <summary>
        /// Gets the columns.
        /// </summary>
        /// <value>The Database Types.</value>
        public DBColumn ReferencedColumn
        {
            get
            {
                return this.referencedColumn;
            }
        }
    }
}
