﻿//-----------------------------------------------------------------------
// <copyright file="ControlExtesions.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//-----------------------------------------------------------------------
namespace Editor
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Windows.Forms;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public static class ControlExtesions
    {

        public static void SuspendLayout(this Control control, bool children)
        {
            for (int index = 0; index < control.Controls.Count; index++)
            {
                control.Controls[index].SuspendLayout(true);
            }
        }

        public static void ResumeLayout(this Control control, bool children)
        {
            for (int index = 0; index < control.Controls.Count; index++)
            {
                control.Controls[index].ResumeLayout(true);
            }
        }

        private const int WM_SETREDRAW = 0x000B;

        public static void BeginUpdate(this Control control, bool children)
        {
            for (int index = 0; index < control.Controls.Count; index++)
            {
                control.Controls[index].BeginUpdate(true);
            }
        }

        public static void EndUpdate(this Control control, bool children)
        {
            for (int index = 0; index < control.Controls.Count; index++)
            {
                control.Controls[index].EndUpdate(true);
            }
        }

        public static void Rebind(this Control control, string propertyName, Object dataSource, string dataMember, bool formattingEnabled, DataSourceUpdateMode updateMode)
        {
            control.DataBindings.Clear();
            control.DataBindings.Add(propertyName, dataSource, dataMember, formattingEnabled, updateMode);
        }

        public static void BeginUpdate(this Control control)
        {
            Message msgSuspendUpdate = Message.Create(control.Handle, WM_SETREDRAW, IntPtr.Zero,
                IntPtr.Zero);

            NativeWindow window = NativeWindow.FromHandle(control.Handle);
            window.DefWndProc(ref msgSuspendUpdate);
        }

        public static void EndUpdate(this Control control)
        {
            // Create a C "true" boolean as an IntPtr
            IntPtr wparam = new IntPtr(1);
            Message msgResumeUpdate = Message.Create(control.Handle, WM_SETREDRAW, wparam,
                IntPtr.Zero);

            NativeWindow window = NativeWindow.FromHandle(control.Handle);
            window.DefWndProc(ref msgResumeUpdate);

            control.Invalidate();
        }
    }
}
