﻿//----------------------------------------------------------------------------
// <copyright file="UserSettings.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//----------------------------------------------------------------------------
namespace Editor
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Configuration;
    using System.Drawing;
    using System.Windows.Forms;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public class UserSettings : ApplicationSettingsBase
    {
        [UserScopedSettingAttribute()]
        [DefaultSettingValueAttribute("")]
        public string AppVersion
        {
            get
            {
                return ((string)(this["AppVersion"]));
            }
            set
            {
                this["AppVersion"] = value;
            }
        }

        private static UserSettings defaultInstance = ((UserSettings)(ApplicationSettingsBase.Synchronized(new UserSettings())));
        public static UserSettings Default
        {
            get
            {
                return defaultInstance;
            }
        }

        [UserScopedSettingAttribute()]
        [DefaultSettingValueAttribute("0, 0")]
        public global::System.Drawing.Point Location
        {
            get
            {
                return ((Point)(this["Location"]));
            }
            set
            {
                this["Location"] = value;
            }
        }

        [UserScopedSetting]
        [DefaultSettingValueAttribute("400, 400")]
        public Size Size
        {
            get
            {
                return ((global::System.Drawing.Size)(this["Size"]));
            }
            set
            {
                this["Size"] = value;
            }
        }

        [UserScopedSettingAttribute()]
        [DefaultSettingValueAttribute("Normal")]
        public global::System.Windows.Forms.FormWindowState State
        {
            get
            {
                return ((FormWindowState)(this["State"]));
            }
            set
            {
                this["State"] = value;
            }
        }
    }
}