﻿//-----------------------------------------------------------------------
// <copyright file="DataAccessInterfaceGenerator.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//-----------------------------------------------------------------------
namespace Dax.Generator
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Dax.Database;
    using System.Diagnostics;
    using System.IO;
    using Dax.Generator.DataAccessInterface.Templates;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public class DataAccessInterfaceGenerator : Generator
    {
        #region Constructors
        /// <summary>
        /// Initializes a new instance of the DataAccessInterfaceGenerator class.
        /// </summary>
        public DataAccessInterfaceGenerator(GenerationProfile profile, DBDatabase database)
            : base(profile, database, profile.DataAccessInterface.VSProjectFile, "Data Acccess Interface", true)
        {
        }
        #endregion

        protected override void GenerationStart()
        {
            // Make sure output directories exist.
            Directory.CreateDirectory(this.Profile.DataAccessInterface.OutputPath);

            this.Session.Add("namespace", this.Profile.DataAccessInterface.Namespace);
        }

        protected override void GenerateDatabase(DBDatabase database)
        {
            this.GenerationFiles.Add(new GenerationFile(this.Profile.DataAccessInterface.OutputFilePath("IDataAccess.cs"), typeof(IDataAccess), this.Database));
            this.GenerationFiles.Add(new GenerationFile(this.Profile.DataAccessInterface.OutputFilePath("DataAccessException.cs"), typeof(DataAccessException), this.Database));
            this.GenerationFiles.Add(new GenerationFile(this.Profile.DataAccessInterface.OutputFilePath("DataAccessConcurrenyException.cs"), typeof(DataAccessConcurrencyException), this.Database));
        }

        protected override void GenerateTable(DBTable table)
        {
            this.GenerationFiles.Add(new GenerationFile(this.Profile.DataAccessInterface.OutputFilePath("I" + table.DARecordClassName() + ".cs"), typeof(IDataRecord), Database, table));
            this.GenerationFiles.Add(new GenerationFile(this.Profile.DataAccessInterface.OutputFilePath("I" + table.DARepositoryClassName() + ".cs"), typeof(IDataRepository), Database, table));
        }
    }
}
