﻿//-----------------------------------------------------------------------
// <copyright file="DBColumnExtensions.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//-----------------------------------------------------------------------
namespace Dax.Generator
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Dax.Database;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public static class DBColumnExtensions
    {
        public static GenerationProfile Profile { get; set; }

        public static string DARecordPrivateVariableName(this DBColumn column)
        {
            return "m" + column.Name;
        }

        public static string CSharpType(this DBColumn column)
        {
            return SqlTypeConverter.FromSql(column.SystemType.Name, column.IsNullable);
        }

        public static bool IsString(this DBColumn column)
        {
            return (column.SystemType.Name.EndsWith("char") || column.SystemType.Name == "datetime" || column.SystemType.Name == "uniqueidentifier");
        }

        public static bool IsBool(this DBColumn column)
        {
            return (column.SystemType.Name == "bit");
        }

        public static bool IsConcurrencyColumn(this DBColumn column)
        {
            return (Profile.DataAccess.ConcurrencyColumn == column.Name);
        }
    }
}
