﻿//-----------------------------------------------------------------------
// <copyright file="DBProcedureExtensions.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//-----------------------------------------------------------------------
namespace Dax.Generator
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Dax.Database;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public static class DBProcedureExtensions
    {
        public static GenerationProfile Profile { get; set; }

        public static string UserName(this DBProcedure procedure)
        {
            string[] s = procedure.Name.Split('.');
            return s[1];
        }

        public static string GetStoredProcedureName(this DBProcedure procedure)
        {
            return "[" + procedure.Schema.Name + "].[" + procedure.Name + "]";
        }

        public static string ParameterListDeclaration(this DBProcedure procedure)
        {
            StringBuilder s = new StringBuilder();

            foreach (var parameter in procedure.Parameters.Values)
            {
                string str = string.Format("{0} {1}", SqlTypeConverter.FromSql(parameter.SystemType.Name, false), parameter.Name.ToCamel());
                if (parameter.IsOutput)
                {
                    str = "out " + str;
                }
                s.AppendCommaList(str);
            }

            return s.ToString();
        }

        public static string ParameterList(this DBProcedure procedure)
        {
            StringBuilder s = new StringBuilder();

            foreach (var parameter in procedure.Parameters.Values)
            {
                string str = parameter.Name.ToCamel();
                if (parameter.IsOutput)
                {
                    str = "out " + str;
                }
                s.AppendCommaList(str);
            }

            return s.ToString();
        }
    }
}
