﻿//-----------------------------------------------------------------------
// <copyright file="GenerationFile.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//-----------------------------------------------------------------------
namespace Dax.Generator
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Dax.Database;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public class GenerationFile
    {
        /// <summary>
        /// Gets or sets the Template.
        /// </summary>
        /// <value>The summary.</value>
        public Type Template
        {
            get;
            set;
        }

        public DBDatabase Database
        {
            get;
            set;
        }

        public DBTable Table
        {
            get;
            set;
        }

        public bool KeepExisting
        {
            get;
            set;
        }

        /// <summary>
        /// Gets the IsDesigner.
        /// </summary>
        /// <value>The IsDesigner.</value>
        public bool IsDesigner
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the FileName.
        /// </summary>
        /// <value>The summary.</value>
        public string FileName
        {
            get;
            set;
        } 

        #region Constructors
        /// <summary>
        /// Initializes a new instance of the GenerationFile class.
        /// </summary>
        public GenerationFile(string fileName, Type templateType, bool isDesigner, bool keepExisting, DBDatabase database)
        {
            this.FileName = fileName;
            this.Template = templateType;
            this.Database = database;
            this.IsDesigner = isDesigner;
            this.KeepExisting = keepExisting;
        }

        public GenerationFile(string fileName, Type templateType, bool isDesigner, bool keepExisting, DBDatabase database, DBTable table)
            : this(fileName, templateType, isDesigner, keepExisting, database)
        {
            this.Table = table;
        }

        public GenerationFile(string fileName, Type templateType, bool isDesigner, DBDatabase database, DBTable table)
            : this(fileName, templateType, isDesigner, false, database, table)
        {
        }

        public GenerationFile(string fileName, Type templateType, DBDatabase database, DBTable table)
            : this(fileName, templateType, false, database, table)
        {
        }

        public GenerationFile(string fileName, Type templateType, DBDatabase database)
            : this(fileName, templateType, false, false, database)
        {
        }
        #endregion
    }
}
