﻿//----------------------------------------------------------------------------
// <copyright file="DatabaseColumn.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//----------------------------------------------------------------------------
namespace Dax.Schema
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public class DatabaseColumn : DatabaseObject
    {
        #region Constructors
        /// <summary>
        /// Initializes a new instance of the DatabaseColumn class.
        /// </summary>
        public DatabaseColumn(string name)
            : base(name.RemoveWhitespace())
        {
        }

        public DatabaseColumn(string name, int id)
            : this(name)
        {
            this.Id = id;
        }

        public DatabaseColumn(string name, int id, DatabaseType databaseType)
            : this(name, id)
        {
            this.DatabaseType = databaseType;
        }

        public DatabaseColumn(string name, int id, DatabaseType databaseType, bool isIdentity)
            : this(name, id,databaseType)
        {
            this.IsIdentity = isIdentity;
        }
        #endregion

        public bool IsPrimaryKey
        {
            get;
            internal set;
        }

        /// <summary>
        /// Gets the summary.
        /// </summary>
        /// <value>The summary.</value>
        public bool IsNullable
        {
            get;
            internal set;
        }

        /// <summary>
        /// Gets the summary.
        /// </summary>
        /// <value>The summary.</value>
        public bool IsComputed
        {
            get;
            internal set;
        }

        /// <summary>
        /// Gets the summary.
        /// </summary>
        /// <value>The summary.</value>
        public bool IsIdentity
        {
            get;
            internal set;
        }

        public bool IsForeignKey
        {
            get;
            internal set;
        }

        /// <summary>
        /// Gets the summary.
        /// </summary>
        /// <value>The summary.</value>
        public DatabaseType DatabaseType
        {
            get;
            internal set;
        }

        /// <summary>
        /// Gets the OrdinalPosition.
        /// </summary>
        /// <value>The OrdinalPosition.</value>
        public int Id
        {
            get;
            internal set;
        }

        /// <summary>
        /// Gets the OrdinalPosition.
        /// </summary>
        /// <value>The OrdinalPosition.</value>
        public int MaxLength
        {
            get;
            internal set;
        }

        /// <summary>
        /// Gets the OrdinalPosition.
        /// </summary>
        /// <value>The OrdinalPosition.</value>
        public int Precision
        {
            get;
            internal set;
        }

        /// <summary>
        /// Gets the OrdinalPosition.
        /// </summary>
        /// <value>The OrdinalPosition.</value>
        public int Scale
        {
            get;
            internal set;
        }

    }
}
