﻿//----------------------------------------------------------------------------
// <copyright file="DatabaseRelationship.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//----------------------------------------------------------------------------
namespace Dax.Schema
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public class DatabaseRelationship : DatabaseObject
    {
        private int objectId;
        private Dictionary<int, DatabaseColumn> parentColumns = new Dictionary<int, DatabaseColumn>();
        private Dictionary<int, DatabaseColumn> referencedColumns = new Dictionary<int, DatabaseColumn>();
        private DatabaseTable parentTable;
        private DatabaseTable referencedTable;

        #region Constructors
        /// <summary>
        /// Initializes a new instance of the DatabaseRelationship class.
        /// </summary>
        public DatabaseRelationship(string name, int objectId, DatabaseTable parentTable, DatabaseTable referencedTable)
            : base(name)
        {
            this.objectId = objectId;
            this.parentTable = parentTable;
            this.referencedTable = referencedTable;
        }
        #endregion

        public void AddParentColumn(int column_id, DatabaseColumn column)
        {
            parentColumns.Add(column_id, column);
        }

        public void AddReferencedColumn(int column_id, DatabaseColumn column)
        {
            referencedColumns.Add(column_id, column);
        }

        /// <summary>
        /// Gets the ObjectId
        /// </summary>
        /// <value>ObjectId</value>
        public int ObjectId
        {
            get
            {
                return this.objectId;
            }
        }

        public DatabaseTable ReferencedTable
        {
            get
            {
                return this.referencedTable;
            }
        }


        public DatabaseTable ParentTable
        {
            get
            {
                return this.parentTable;
            }
        }

        public List<DatabaseColumn> ParentColumns
        {
            get
            {
                return this.parentColumns.Values.ToList();
            }
        }

        public List<DatabaseColumn> ReferencedColumns
        {
            get
            {
                return this.referencedColumns.Values.ToList();
            }
        }
    }
}
