﻿//----------------------------------------------------------------------------
// <copyright file="DatabaseType.cs" company="Russell Wilkins">
//     Copyright (c) 2011 Russell Wilkins 2011. All rights reserved.
//
//     The use of this software is governed by the Microsoft Public License
//     which is included with this distribution.
// </copyright>
//----------------------------------------------------------------------------
namespace Dax.Schema
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// TODO: Describe the class
    /// </summary>
    public class DatabaseType : DatabaseObject
    {
        private int userTypeId;
        private int systemTypeId;
        private DatabaseSchema schema;

        #region Constructors
        /// <summary>
        /// Initializes a new instance of the DatabaseType class.
        /// </summary>
        public DatabaseType(DatabaseSchema schema, string name, int userTypeId, int systemTypeId)
            : base(name)
        {
            this.schema = schema;
            this.userTypeId = userTypeId;
            this.systemTypeId = systemTypeId;
        }
        #endregion

        public string TypeName
        {
            get
            {
                if (this.systemTypeId != this.userTypeId)
                {
                    return this.schema.GetType(this.systemTypeId).TypeName;
                }
                else
                {
                    return this.Name;
                }
            }
        }

        public int UserTypeId
        {
            get
            {
                return this.userTypeId;
            }
        }

        public int SystemTypeId
        {
            get
            {
                return this.systemTypeId;
            }
        }
    }
}
